diff --git a/hw/block/xen_disk.c b/hw/block/xen_disk.c
index 5aa350a..24edeb2 100644
--- a/hw/block/xen_disk.c
+++ b/hw/block/xen_disk.c
@@ -1068,7 +1068,8 @@ static int blk_connect(struct XenDevice *xendev)
         blk_set_enable_write_cache(blkdev->blk, !writethrough);
     } else {
         /* setup via qemu cmdline -> already setup for us */
-        xen_be_printf(&blkdev->xendev, 2, "get configured bdrv (cmdline setup)\n");
+        xen_be_printf(&blkdev->xendev, 2,
+                     "get configured bdrv (cmdline setup)\n");
         blkdev->blk = blk_by_legacy_dinfo(blkdev->dinfo);
         if (blk_is_read_only(blkdev->blk) && !readonly) {
             xen_be_printf(&blkdev->xendev, 0, "Unexpected read-only drive");
diff --git a/hw/char/xen_console.c b/hw/char/xen_console.c
index 4e35c82..399bb5d 100644
--- a/hw/char/xen_console.c
+++ b/hw/char/xen_console.c
@@ -156,7 +156,8 @@ static void xencons_send(struct XenConsole *con)
     if (len < 1) {
         if (!con->backlog) {
             con->backlog = 1;
-            xen_be_printf(&con->xendev, 1, "backlog piling up, nobody listening?\n");
+            xen_be_printf(&con->xendev, 1,
+                         "backlog piling up, nobody listening?\n");
         }
     } else {
         buffer_advance(&con->buffer, len);
@@ -247,7 +248,8 @@ static int con_initialise(struct XenDevice *xendev)
         }
     }
 
-    xen_be_printf(xendev, 1, "ring mfn %d, remote port %d, local port %d, limit %zd\n",
+    xen_be_printf(xendev, 1,
+                 "ring mfn %d, remote port %d, local port %d, limit %zd\n",
 		  con->ring_ref,
 		  con->xendev.remote_port,
 		  con->xendev.local_port,
diff --git a/hw/display/xenfb.c b/hw/display/xenfb.c
index a9a93f9..9bcf60b 100644
--- a/hw/display/xenfb.c
+++ b/hw/display/xenfb.c
@@ -511,38 +511,45 @@ static int xenfb_configure_fb(struct XenFB *xenfb, size_t fb_len_lim,
     int max_width, max_height;
 
     if (fb_len_lim > fb_len_max) {
-        xen_be_printf(&xenfb->c.xendev, 0, "fb size limit %zu exceeds %zu, corrected\n",
+        xen_be_printf(&xenfb->c.xendev, 0,
+                     "fb size limit %zu exceeds %zu, corrected\n",
                       fb_len_lim, fb_len_max);
         fb_len_lim = fb_len_max;
     }
     if (fb_len_lim && fb_len > fb_len_lim) {
-        xen_be_printf(&xenfb->c.xendev, 0, "frontend fb size %zu limited to %zu\n",
+        xen_be_printf(&xenfb->c.xendev, 0,
+                     "frontend fb size %zu limited to %zu\n",
                       fb_len, fb_len_lim);
         fb_len = fb_len_lim;
     }
     if (depth != 8 && depth != 16 && depth != 24 && depth != 32) {
-        xen_be_printf(&xenfb->c.xendev, 0, "can't handle frontend fb depth %d\n",
+        xen_be_printf(&xenfb->c.xendev, 0,
+                     "can't handle frontend fb depth %d\n",
                       depth);
         return -1;
     }
     if (row_stride <= 0 || row_stride > fb_len) {
-        xen_be_printf(&xenfb->c.xendev, 0, "invalid frontend stride %d\n", row_stride);
+        xen_be_printf(&xenfb->c.xendev, 0, "invalid frontend stride %d\n",
+                      row_stride);
         return -1;
     }
     max_width = row_stride / (depth / 8);
     if (width < 0 || width > max_width) {
-        xen_be_printf(&xenfb->c.xendev, 0, "invalid frontend width %d limited to %d\n",
+        xen_be_printf(&xenfb->c.xendev, 0,
+                     "invalid frontend width %d limited to %d\n",
                       width, max_width);
         width = max_width;
     }
     if (offset < 0 || offset >= fb_len) {
-        xen_be_printf(&xenfb->c.xendev, 0, "invalid frontend offset %d (max %zu)\n",
+        xen_be_printf(&xenfb->c.xendev, 0,
+                     "invalid frontend offset %d (max %zu)\n",
                       offset, fb_len - 1);
         return -1;
     }
     max_height = (fb_len - offset) / row_stride;
     if (height < 0 || height > max_height) {
-        xen_be_printf(&xenfb->c.xendev, 0, "invalid frontend height %d limited to %d\n",
+        xen_be_printf(&xenfb->c.xendev, 0,
+                     "invalid frontend height %d limited to %d\n",
                       height, max_height);
         height = max_height;
     }
@@ -554,7 +561,8 @@ static int xenfb_configure_fb(struct XenFB *xenfb, size_t fb_len_lim,
     xenfb->offset = offset;
     xenfb->up_fullscreen = 1;
     xenfb->do_resize = 1;
-    xen_be_printf(&xenfb->c.xendev, 1, "framebuffer %dx%dx%d offset %d stride %d\n",
+    xen_be_printf(&xenfb->c.xendev, 1,
+                 "framebuffer %dx%dx%d offset %d stride %d\n",
                   width, height, depth, offset, row_stride);
     return 0;
 }
@@ -722,7 +730,8 @@ static void xenfb_update(void *opaque)
             break;
         }
         dpy_gfx_replace_surface(xenfb->c.con, surface);
-        xen_be_printf(&xenfb->c.xendev, 1, "update: resizing: %dx%d @ %d bpp%s\n",
+        xen_be_printf(&xenfb->c.xendev, 1,
+                     "update: resizing: %dx%d @ %d bpp%s\n",
                       xenfb->width, xenfb->height, xenfb->depth,
                       is_buffer_shared(surface) ? " (shared)" : "");
         xenfb->up_fullscreen = 1;
@@ -733,7 +742,8 @@ static void xenfb_update(void *opaque)
         xen_be_printf(&xenfb->c.xendev, 3, "update: fullscreen\n");
         xenfb_guest_copy(xenfb, 0, 0, xenfb->width, xenfb->height);
     } else if (xenfb->up_count) {
-        xen_be_printf(&xenfb->c.xendev, 3, "update: %d rects\n", xenfb->up_count);
+        xen_be_printf(&xenfb->c.xendev, 3, "update: %d rects\n",
+                      xenfb->up_count);
         for (i = 0; i < xenfb->up_count; i++)
             xenfb_guest_copy(xenfb,
                              xenfb->up_rects[i].x,
diff --git a/hw/net/xen_nic.c b/hw/net/xen_nic.c
index f401cd2..30efe47 100644
--- a/hw/net/xen_nic.c
+++ b/hw/net/xen_nic.c
@@ -140,7 +140,8 @@ static void net_tx_packets(struct XenNetDev *netdev)
 #endif
 
             if (txreq.size < 14) {
-                xen_be_printf(&netdev->xendev, 0, "bad packet size: %d\n", txreq.size);
+                xen_be_printf(&netdev->xendev, 0, "bad packet size: %d\n",
+                              txreq.size);
                 net_tx_error(netdev, &txreq, rc);
                 continue;
             }
@@ -213,7 +214,8 @@ static void net_rx_response(struct XenNetDev *netdev,
         resp->status = (int16_t)st;
     }
 
-    xen_be_printf(&netdev->xendev, 3, "rx response: idx %d, status %d, flags 0x%x\n",
+    xen_be_printf(&netdev->xendev, 3,
+                 "rx response: idx %d, status %d, flags 0x%x\n",
                   i, resp->status, resp->flags);
 
     netdev->rx_ring.rsp_prod_pvt = ++i;
@@ -256,7 +258,8 @@ static ssize_t net_rx_packet(NetClientState *nc, const uint8_t *buf, size_t size
                                    netdev->xendev.dom,
                                    rxreq.gref, PROT_WRITE);
     if (page == NULL) {
-        xen_be_printf(&netdev->xendev, 0, "error: rx gref dereference failed (%d)\n",
+        xen_be_printf(&netdev->xendev, 0,
+                     "error: rx gref dereference failed (%d)\n",
                       rxreq.gref);
         net_rx_response(netdev, &rxreq, NETIF_RSP_ERROR, 0, 0, 0);
         return -1;
@@ -330,7 +333,8 @@ static int net_connect(struct XenDevice *xendev)
         rx_copy = 0;
     }
     if (rx_copy == 0) {
-        xen_be_printf(&netdev->xendev, 0, "frontend doesn't support rx-copy.\n");
+        xen_be_printf(&netdev->xendev, 0,
+                     "frontend doesn't support rx-copy.\n");
         return -1;
     }
 
diff --git a/hw/xen/xen_backend.c b/hw/xen/xen_backend.c
index 545ee47..0aca6ae 100644
--- a/hw/xen/xen_backend.c
+++ b/hw/xen/xen_backend.c
@@ -53,7 +53,8 @@ struct xs_dirs {
 static QTAILQ_HEAD(xs_dirs_head, xs_dirs) xs_cleanup =
     QTAILQ_HEAD_INITIALIZER(xs_cleanup);
 
-static QTAILQ_HEAD(XenDeviceHead, XenDevice) xendevs = QTAILQ_HEAD_INITIALIZER(xendevs);
+static QTAILQ_HEAD(XenDeviceHead, XenDevice) xendevs =
+    QTAILQ_HEAD_INITIALIZER(xendevs);
 static int debug;
 
 /* ------------------------------------------------------------- */
@@ -205,7 +206,8 @@ int xenstore_read_fe_int(struct XenDevice *xendev, const char *node, int *ival)
     return xenstore_read_int(xendev->fe, node, ival);
 }
 
-int xenstore_read_fe_uint64(struct XenDevice *xendev, const char *node, uint64_t *uval)
+int xenstore_read_fe_uint64(struct XenDevice *xendev, const char *node,
+                                                        uint64_t *uval)
 {
     return xenstore_read_uint64(xendev->fe, node, uval);
 }
@@ -385,7 +387,8 @@ static void xen_be_frontend_changed(struct XenDevice *xendev, const char *node)
         g_free(xendev->protocol);
         xendev->protocol = xenstore_read_fe_str(xendev, "protocol");
         if (xendev->protocol) {
-            xen_be_printf(xendev, 1, "frontend protocol: %s\n", xendev->protocol);
+            xen_be_printf(xendev, 1, "frontend protocol: %s\n",
+                                                xendev->protocol);
         }
     }
 
@@ -617,7 +620,8 @@ static int xenstore_scan(const char *type, int dom, struct XenDevOps *ops)
     snprintf(token, sizeof(token), "be:%p:%d:%p", type, dom, ops);
     snprintf(path, sizeof(path), "backend/%s/%d", type, dom);
     if (!xs_watch(xenstore, path, token)) {
-        xen_be_printf(NULL, 0, "xen be: watching backend path (%s) failed\n", path);
+        xen_be_printf(NULL, 0, "xen be: watching backend path (%s) failed\n",
+                      path);
         return -1;
     }
 
@@ -830,7 +834,8 @@ int xen_be_send_notify(struct XenDevice *xendev)
  *  2 == noisy debug messages (logfile only).
  *  3 == will flood your log (logfile only).
  */
-void xen_be_printf(struct XenDevice *xendev, int msg_level, const char *fmt, ...)
+void xen_be_printf(struct XenDevice *xendev, int msg_level,
+                                        const char *fmt, ...)
 {
     va_list args;
 
diff --git a/include/hw/xen/xen_backend.h b/include/hw/xen/xen_backend.h
index 0df282a..0ccbc0f 100644
--- a/include/hw/xen/xen_backend.h
+++ b/include/hw/xen/xen_backend.h
@@ -79,7 +79,8 @@ int xenstore_read_be_int(struct XenDevice *xendev, const char *node, int *ival);
 char *xenstore_read_fe_str(struct XenDevice *xendev, const char *node);
 int xenstore_read_fe_int(struct XenDevice *xendev, const char *node, int *ival);
 int xenstore_read_uint64(const char *base, const char *node, uint64_t *uval);
-int xenstore_read_fe_uint64(struct XenDevice *xendev, const char *node, uint64_t *uval);
+int xenstore_read_fe_uint64(struct XenDevice *xendev, const char *node,
+                                                        uint64_t *uval);
 
 const char *xenbus_strstate(enum xenbus_state state);
 struct XenDevice *xen_be_find_xendev(const char *type, int dom, int dev);
@@ -93,8 +94,9 @@ int xen_be_set_state(struct XenDevice *xendev, enum xenbus_state state);
 int xen_be_bind_evtchn(struct XenDevice *xendev);
 void xen_be_unbind_evtchn(struct XenDevice *xendev);
 int xen_be_send_notify(struct XenDevice *xendev);
-void xen_be_printf(struct XenDevice *xendev, int msg_level, const char *fmt, ...)
-    GCC_FMT_ATTR(3, 4);
+void xen_be_printf(struct XenDevice *xendev, int msg_level,
+                const char *fmt, ...)  GCC_FMT_ATTR(3, 4);
+
 
 /* actual backend drivers */
 extern struct XenDevOps xen_console_ops;      /* xen_console.c     */